Summary: Generic SPARC linux kernel
Name: kernel-sparc
Version: 2.0.35
Release: 15.4.2
%define	kversion %{PACKAGE_VERSION}
Copyright: GPL
Group: Base/Kernel
ExclusiveArch: sparc
ExclusiveOS: Linux
Source0: vger.rutgers.edu:/pub/linux/Sparc/kernel/v2.0/980805/sparclinux-2.0-980805.tar.gz
Source1: kernel-config.sparc
Source2: module-info
Source3: rhkmvtag.c
Source4: audio-2.0.35-980829.tar.gz
# patches 0 & 3-5 applied and deleted
Patch1: kernel-smp.patch
Patch2: linux-2.0.33-freemem.patch
# XXX Apply this patch to use CC=sparc-linux-gcc
Patch6: kernel-egcs.patch
Patch7: kernel-2.0.36-rh52.patch
Patch8: kernel-2.0.36-listening.patch
Patch9: kernel-2.0.36-rh521.patch
Patch10: kernel-2.0.36-random.patch
BuildRoot: /var/tmp/%{name}-root
Provides: module-info
Autoreqprov: no

%package smp
Summary: SPARC linux kernel for multiprocessor machines
Group: Base/Kernel

%description smp
This package contains the Linux kernel that is used to boot and run
your system. It includes support for machines with multiple processors,
which will signicicantly improve performance on multiprocessor machines.
It will reduce performance on a single processor machine however. Most 
hardware is instead supported by modules loaded after booting.

%package -n kernel-source
Summary: Kernel source tree
Group: Base/Kernel
Requires: kernel-headers = %{kversion}

%package -n kernel-modules
Requires: kernel-sparc = %{kversion}
Summary: Collection of kernel modules
Group: Base/Kernel

%package -n kernel-headers
Summary: Header files for the Linux kernel.
Group: Base/Kernel
Provides: kernel-headers

%description -n kernel-headers
These are the C header files for the Linux kernel, which define structures
and constants that are needed when building most standard programs under
Linux, as well as to rebuild the kernel.

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%description -n kernel-source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description -n kernel-modules
This package includes the modules which provide the support for most
supported hardware devices.  The modules are loaded into the running
kernel after it is booted.

%prep
%setup -q -n linux
# add new audio snapshot
%setup -n linux -T -D -a 4

find . -name "*.orig" -print | xargs rm -f

%ifarch sparc
cp $RPM_SOURCE_DIR/kernel-config.sparc arch/sparc/defconfig
%endif

# patches 0 & 3-5 applied and deleted
%patch2 -p1

# XXX Apply this patch to use CC=sparc-linux-gcc
#%patch6 -p1

%patch7 -p1 -b .rh52
%patch8 -p1 -b .listening

%patch9 -p1 -b .rh521
%patch10 -p1 -b .random

# Bring in the Red Hat Kernel Module Version Tag program
cp $RPM_SOURCE_DIR/rhkmvtag.c .

# this is a bit silly, but we happen to have a dual processor sparc
# build machine so what the heck
if [ -f /proc/cpuinfo ]; then
    num=`awk -F: '/ncpus probed/ { print ($2 * 2) + 1; }' /proc/cpuinfo`
    mv Makefile Makefile.onecpu
    sed "s/^MAKE.*=make$/MAKE=make -j $num/" < Makefile.onecpu > Makefile
fi

%build

make oldconfig symlinks
make include/linux/version.h

make vmlinux modules

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
ln -s ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux
ln -s ../src/linux/include/scsi $RPM_BUILD_ROOT/usr/include/scsi

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion} $RPM_BUILD_ROOT/boot

install -m644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info
install -m644 System.map $RPM_BUILD_ROOT/boot/System.map-%{kversion}

strip vmlinux
gzip -9nf vmlinux
install -m755  vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinux-%{kversion}.gz
rm -f vmlinux.gz

mkdir -p $RPM_BUILD_ROOT/lib/modules
make DESTDIR=$RPM_BUILD_ROOT modules_install

# Identify the modules directory with the Red Hat Kernel Module Version Tag
cc -o rhkmvtag rhkmvtag.c init/version.o
./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/%{kversion}/.rhkmvtag
rm -f rhkmvtag

# XXX don't rename modules dir
## move the modules to where we like them
#mv $RPM_BUILD_ROOT/lib/modules/%{kversion} \
#   $RPM_BUILD_ROOT/lib/modules/%{KVERREL}

# now build the SMP flavor

patch -p1 < $RPM_SOURCE_DIR/kernel-smp.patch
make clean Version oldconfig	# nuke include/linux/compile.h for rhkmvtag.

make vmlinux modules

install -m644 $RPM_SOURCE_DIR/module-info $RPM_BUILD_ROOT/boot/module-info-smp
install -m644 System.map $RPM_BUILD_ROOT/boot/System.map-smp-%{kversion}

strip vmlinux
gzip -9nf vmlinux
install -m755 vmlinux.gz $RPM_BUILD_ROOT/boot/vmlinux-smp-%{kversion}.gz

# XXX don't distribute smp modules
#make DESTDIR=$RPM_BUILD_ROOT modules_install

# Identify the modules directory with the Red Hat Kernel Module Version Tag
cc -o rhkmvtag rhkmvtag.c init/version.o
./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/%{kversion}/.rhkmvtag
rm -f rhkmvtag

# XXX don't distribute smp modules
## move the modules to where we like them
#mv $RPM_BUILD_ROOT/lib/modules/%{kversion} \
#   $RPM_BUILD_ROOT/lib/modules/%{kversion}-smp

mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
ln -sf linux-%{kversion} $RPM_BUILD_ROOT/usr/src/linux

cp -a . $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

# keep kernel-source archive clean
make mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make oldconfig -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make symlinks -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
make include/linux/version.h -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}

#this generates modversions info which we want to include and we may as
#well include the depends stuff as well, after we fix the paths
make depend -C $RPM_BUILD_ROOT/usr/src/linux-%{kversion}
find $RPM_BUILD_ROOT/usr/src/linux-%{kversion} -name ".*depend" | \
while read file ; do
    mv $file $file.old
    sed -e "s|[^ ]*\(/usr/src/linux\)|\1|g" < $file.old > $file
    rm -f $file.old
done

# make /usr/include/scsi link
mkdir -p $RPM_BUILD_ROOT/usr/include
ln -s /usr/src/linux/include/scsi $RPM_BUILD_ROOT/usr/include/scsi

%clean
rm -rf $RPM_BUILD_ROOT

%preun -n kernel-modules
if [ `uname -r` = "%{kversion}" ]; then 
	echo "You cannot remove the kernel-modules package for the currently "
	echo "running kernel".
	exit 1
fi
rm -f /lib/modules/%{kversion}/modules.dep

%post
ln -sf /boot/vmlinux-%{kversion}.gz /boot/vmlinux.gz
ln -sf /boot/System.map-%{kversion} /boot/System.map

%post -n kernel-headers
cd /usr/src
ln -snf linux-%{kversion} linux

%postun
if [ -L /usr/src/linux ]; then
    if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{kversion}" ]; then
        rm -f /usr/src/linux
    fi
fi

%files
%defattr(-,root,root)
/boot/vmlinux-%{kversion}.gz
/boot/module-info
/boot/System.map-%{kversion}

%files smp
%defattr(-,root,root)
/boot/vmlinux-smp-%{kversion}.gz
/boot/module-info-smp
/boot/System.map-smp-%{kversion}

%files -n kernel-source
%defattr(-,root,root)
%dir /usr/src/linux-%{kversion}
/usr/src/linux-%{kversion}/COPYING
/usr/src/linux-%{kversion}/CREDITS
/usr/src/linux-%{kversion}/Documentation
/usr/src/linux-%{kversion}/MAINTAINERS
/usr/src/linux-%{kversion}/Makefile
/usr/src/linux-%{kversion}/README
/usr/src/linux-%{kversion}/Rules.make
/usr/src/linux-%{kversion}/arch
/usr/src/linux-%{kversion}/drivers
/usr/src/linux-%{kversion}/fs
/usr/src/linux-%{kversion}/init
/usr/src/linux-%{kversion}/ipc
/usr/src/linux-%{kversion}/kernel
/usr/src/linux-%{kversion}/lib
/usr/src/linux-%{kversion}/mm
/usr/src/linux-%{kversion}/modules
/usr/src/linux-%{kversion}/net
/usr/src/linux-%{kversion}/scripts

%files -n kernel-headers
%defattr(-,root,root)
/usr/src/linux-%{kversion}/include/asm
/usr/src/linux-%{kversion}/include/asm-generic
/usr/src/linux-%{kversion}/include/linux
/usr/src/linux-%{kversion}/include/net
/usr/src/linux-%{kversion}/include/scsi
/usr/include/asm
/usr/include/linux
/usr/include/scsi
/usr/src/linux-%{kversion}/include/asm-sparc

%files -n kernel-modules
%defattr(-,root,root)
%dir /lib/modules
%dir /lib/modules/%{kversion}
/lib/modules/%{kversion}/.rhkmvtag
/lib/modules/%{kversion}/block
/lib/modules/%{kversion}/fs
/lib/modules/%{kversion}/ipv4
/lib/modules/%{kversion}/misc
/lib/modules/%{kversion}/net
/lib/modules/%{kversion}/scsi

%changelog
* Wed Dec 30 1998 Jeff Johnson <jbj@redhat.com>
- enable latest audio driver.
- /dev/random fixes.

* Tue Nov 17 1998 Jeff Johnson <jbj@redhat.com>
- security fixes from official 2.0.36

* Wed Nov  4 1998 Bill Nottingham <notting@redhat.com>
- add newer audio snapshot
